/* arpeggiate -- sample "interface" for RTcmix
 * 
 * uses the basic "STRUM" instrument
 * 
 * BGG 
*/


#include <stdio.h>

#include "/musr/cmix/H/RTsockfuncs.h"
#include "/musr/cmix/H/randfuncs.h"

int theSock;

main()
{
	int RTpid;
	void gonotes();
	float measure;
	char name[100];
	char c;


	/* start up the instrument */
/*
	RTpid = RTopensocket(0, "STRUM");
*/
	sleep(3); /* allow the process time to start */

	/* get name of server */
	printf("enter host name of server: ");
	scanf("%s",name);

	/* open up the socket */
	theSock = RTsock(name, 0);

	/* set up the instrument */
	RTsendsock("rtsetparams", theSock, 2, 44100.0, 2.0);
	RTsendsock("load", theSock, 1, "STRUM");
	RTsendsock("print_off", theSock, 0);

	/* set up a timed function */
	measure = 0.8;
	RTtimeit(measure, gonotes);


	printf("type \"q\" and carriage-return to stop\n");
	fflush(stdout);
	while(1) {
		c = getchar();
		if (c == 'q') { /* quit! */
			RTkillsocket(theSock, RTpid);
			sleep(3); /* shut down time */
			return(1);
		}
	}

}


void
gonotes()
{
	float pitches[14] = {6.05, 6.07, 6.10, 7.00, 7.02, 7.04, 7.05, 7.07, 7.09, 8.00, 8.02, 8.05, 8.07, 8.10};
	float start,pval;
	int i;
	float brrand(); /* returns a random number between 0 and 1 */

	start = 1.0;
	for (i = 0; i < 8; i++) { /* schedule 8 notes 0.1 secs apart */
		pval = pitches[(int)(brrand() * 14.0)];
		RTsendsock("START", theSock, 9, start, 1.0, pval, 1.0, 0.7, 7000.0, 1.0, brrand(), 1.0);
		start += 0.1;
	}
}
